// https://github.com/PictonStreetMedia/cordova-plugin-admob
bento.define('ads/admob', [
    'bento',
    'utils'
], function (
    Bento,
    Utils
) {
    'use strict';
    var canShow = false,
        isLoading = false,
        admobid = {},
        loadAd = function () {
            if (isLoading) {
                return;
            }
            isLoading = true;
            // put loading here
            if (window.AdMob && window.AdMob.prepareInterstitial) {
                console.log('prepare admob', JSON.stringify(window.AdMob))
                window.AdMob.prepareInterstitial({
                    adId: admobid.interstitial,
                    autoShow: false
                }, function () {
                    // success
                console.log('admob loaded')
                    isLoading = false;
                    canShow = true;
                }, function () {
                console.log('admob failed')
                    // fail
                    isLoading = false;
                });
            } else {
                console.log('WARNING: Admob plugin error');
            }
        },
        nothing = function () {};

    // init here
    if (window.AdMob) {
        if (Utils.isNativeIos()) { // for ios
            admobid = {
                interstitial: 'ca-app-pub-6678059861425558/4161817822'
            };
        } else { // for android
            admobid = {
                interstitial: 'ca-app-pub-6678059861425558/5778151829'
            };
        }

    }

    // start with loading
    loadAd();

    return {
        canShow: function () {
            return canShow;
        },
        show: function (callback, endCallback) {
            var end = function () {
                if (endCallback) {
                    endCallback();
                }
                loadAd();
                canShow = false;
                document.removeEventListener('onAdDismiss', end);
            };
            // show here and set callback
            if (AdMob) {
                AdMob.showInterstitial();
            }
            document.addEventListener('onAdDismiss', end);
        },
        load: loadAd
    };
});