bento.define('ads/heyzap', [
    'bento',
    'utils',
    'ads/ironsrc'
], function (
    Bento,
    Utils,
    IronSrc
) {
    'use strict';
    var canShow = false,
        canShowIncentive = false,
        canShowInterstitial = false,
        isLoading = false,
        isLoadingIncentive = false,
        isLoadingInterstitial = false,
        hasCompletedReward = false,
        hasWatched = false, // trigger for COMPLETE and INCOMPLETE
        hasClosed = false, // trigger for HIDE
        loadAdVideo = function (type) {
            // deprecated in Heyzap sdk 10
            return;
            /*if (!isLoading && !canShow) {
                isLoading = true;
                // put loading here
                window.HeyzapAds.VideoAd.fetch().then(function () {
                    // Native call successful.
                    console.log('heyzap fetch');
                }, function (error) {
                    // Handle Error
                    console.log('heyzap error', error);

                });
            }*/
        },
        loadAdIncentive = function () {
            if (!isLoadingIncentive && !canShowIncentive) {
                isLoadingIncentive = true;
                // put loading here
                window.HeyzapAds.IncentivizedAd.fetch().then(function () {
                    // Native call successful.
                    console.log('heyzap fetch incentive');
                }, function (error) {
                    // Handle Error
                    console.log('heyzap error incentive', error);

                });
            }
        },
        loadAdInterstitial = function () {
            if (!isLoadingInterstitial && !canShowInterstitial) {
                isLoadingInterstitial = true;
                // put loading here
                window.HeyzapAds.InterstitialAd.fetch().then(function () {
                    // Native call successful.
                    console.log('heyzap fetch interstitial');
                }, function (error) {
                    // Handle Error
                    console.log('heyzap error interstitial', error);

                });
            }
        },
        onHide = function () {},
        nothing = function () {};

    if (window.plugins && window.plugins.ironsource) {
        // prefer iron source
        return IronSrc;
    }

    // init here
    if (!window.HeyzapAds) {
        return {
            canShow: function () {
                return false;
            },
            show: nothing,
            load: nothing,
            block: nothing,
            canShowVideo: function () {
                return false;
            },
            showVideo: nothing,
            canShowInterstitial: function () {
                return false;
            },
            showInterstitial: function () {},
            canShowRewarded: function () {},
            showRewarded: function (callback, endCallback) {}
        };
    }

    window.HeyzapAds.start(
        "91b3d6fb3d24302d58cf3957af953124"
        /*,
        new window.HeyzapAds.Options({
            disableAutomaticPrefetch: true,
            disableAutomaticIAPRecording: true
        })*/
    ).then(function () {
        /**
         * SHOW
         */
        window.HeyzapAds.IncentivizedAd.addEventListener(window.HeyzapAds.IncentivizedAd.Events.SHOW, function (tag) {
            console.log('Heyzap IncentivizedAd SHOW event');
            // The ad was successfully shown.
        });
        window.HeyzapAds.InterstitialAd.addEventListener(window.HeyzapAds.InterstitialAd.Events.SHOW, function (tag) {
            console.log('Heyzap InterstitialAd SHOW event');
            // The ad was successfully shown.
        });

        /**
         * COMPLETED
         */
        window.HeyzapAds.IncentivizedAd.addEventListener(window.HeyzapAds.IncentivizedAd.Events.COMPLETE, function (tag) {
            console.log('Heyzap IncentivizedAd COMPLETE event');
            hasCompletedReward = true;
            hasWatched = true;
            if (onHide && hasClosed) {
                onHide(true);
            }
        });
        window.HeyzapAds.IncentivizedAd.addEventListener(window.HeyzapAds.IncentivizedAd.Events.INCOMPLETE, function (tag) {
            console.log('Heyzap IncentivizedAd INCOMPLETE event');
            hasCompletedReward = false;
            hasWatched = true;
            if (onHide && hasClosed) {
                onHide(false);
            }
        });
        /**
         * HIDE
         */
        window.HeyzapAds.IncentivizedAd.addEventListener(window.HeyzapAds.IncentivizedAd.Events.HIDE, function (tag) {
            console.log('Heyzap IncentivizedAd HIDE event');
            // The ad successfully finished showing and is now off the screen.
            hasClosed = true;
            if (onHide && hasWatched) {
                onHide(hasCompletedReward);
            }
            canShowIncentive = false;
            loadAdIncentive();
        });
        window.HeyzapAds.InterstitialAd.addEventListener(window.HeyzapAds.InterstitialAd.Events.HIDE, function (tag) {
            console.log('Heyzap InterstitialAd HIDE event');
            // The ad successfully finished showing and is now off the screen.
            if (onHide) {
                onHide(true);
            }
            canShowInterstitial = false;
            loadAdInterstitial();
        });

        /**
         * SHOW FAILED
         */
        window.HeyzapAds.IncentivizedAd.addEventListener(window.HeyzapAds.IncentivizedAd.Events.SHOW_FAILED, function (tag, error) {
            console.log('Heyzap IncentivizedAd SHOW_FAILED event');
            if (Utils && Utils.Analytics) {
                Utils.Analytics.event('Game', 'Heyzap-Failure');
            }
            if (Utils && Utils.Firebase) {
                Utils.Firebase.logEvent('ad_failure', {
                    ad_network: 'Heyzap'
                });
            }
            if (onHide) {
                onHide(false);
            }
            hasCompletedReward = false;
            // The ad could not be shown successfully.
            window.setTimeout(function () {
                loadAdIncentive();
            }, 30000);
        });
        window.HeyzapAds.InterstitialAd.addEventListener(window.HeyzapAds.InterstitialAd.Events.SHOW_FAILED, function (tag, error) {
            console.log('Heyzap InterstitialAd SHOW_FAILED event');
            if (onHide) {
                onHide(false);
            }
            //The ad could not be shown successfully.
            window.setTimeout(function () {
                loadAdInterstitial();
            }, 10000);
        });

        /**
         * FETCH FAILED
         */
        window.HeyzapAds.IncentivizedAd.addEventListener(window.HeyzapAds.IncentivizedAd.Events.FETCH_FAILED, function (tag, error) {
            console.log('Heyzap IncentivizedAd FETCH_FAILED event');
            isLoadingIncentive = false;
            // The ad could not be fetched.
            window.setTimeout(function () {
                loadAdIncentive();
            }, 30000);
        });
        window.HeyzapAds.InterstitialAd.addEventListener(window.HeyzapAds.InterstitialAd.Events.FETCH_FAILED, function (tag, error) {
            console.log('Heyzap InterstitialAd FETCH_FAILED event');
            isLoadingInterstitial = false;
            // The ad could not be fetched.
            window.setTimeout(function () {
                loadAdInterstitial();
            }, 30000);
        });

        /**
         * AVAILABLE
         */
        window.HeyzapAds.IncentivizedAd.addEventListener(window.HeyzapAds.IncentivizedAd.Events.AVAILABLE, function (tag) {
            console.log('Heyzap IncentivizedAd AVAILABLE event');
            // An ad is available for display.
            canShowIncentive = true;
            isLoadingIncentive = false;
        });
        window.HeyzapAds.InterstitialAd.addEventListener(window.HeyzapAds.InterstitialAd.Events.AVAILABLE, function (tag) {
            console.log('Heyzap InterstitialAd AVAILABLE event');
            // An ad is available for display.
            canShowInterstitial = true;
            isLoadingInterstitial = false;
        });

        // Start fetching ads
        console.log('heyzap started');
        // console.log(JSON.stringify(HeyzapAds.showMediationTestSuite()));
        // return window.HeyzapAds.showMediationTestSuite();
        // loadAdVideo();
        loadAdIncentive();
        loadAdInterstitial();
    }, function (error) {
        // Handle Error
    });

    return {
        canShow: function () {
            if (!navigator.onLine) {
                return false;
            }
            return canShow || canShowIncentive || canShowInterstitial;
        },
        show: function (callback, endCallback) {
            var end = function () {

            };
            // show here and set callback
            if (canShowIncentive) {
                window.HeyzapAds.IncentivizedAd.show().then(function () {}, function (error) {});
                hasCompletedReward = false;
                hasWatched = false;
                hasClosed = false;
            } else if (canShow) {
                window.HeyzapAds.VideoAd.show().then(function () {}, function (error) {});
                hasCompletedReward = true; // cannot detect
            } else if (canShowInterstitial) {
                // do we want to show interstitials?
                window.HeyzapAds.InterstitialAd.show().then(function () {}, function (error) {});
                hasCompletedReward = true; // cannot detect
            } else {
                //
                console.error('You should not call show() before canShow()');
            }
            onHide = endCallback;
        },
        load: function () {
            // loadAdVideo();
            loadAdIncentive();
            loadAdInterstitial();
        },
        block: function () {
            canShow = false;
            canShowIncentive = false;
            canShowInterstitial = false;
            this.isBlocking = true;
        },
        canShowRewarded: function () {
            // fallback to video
            if (!navigator.onLine) {
                return false;
            }
            return canShowIncentive;
        },
        showRewarded: function (callback, endCallback) {
            // show rewarded
            if (canShowIncentive) {
                window.HeyzapAds.IncentivizedAd.show().then(function () {}, function (error) {});
                hasCompletedReward = false;
                hasWatched = false;
                hasClosed = false;
            }
            /*else if (canShow) {
                window.HeyzapAds.VideoAd.show().then(function () {}, function (error) {});
                hasCompletedReward = true; // cannot detect
            } else if (canShowInterstitial) {
                window.HeyzapAds.InterstitialAd.show().then(function () {}, function (error) {});
                hasCompletedReward = true; // cannot detect
            }*/
            onHide = endCallback;
        },
        canShowVideo: function () {
            console.log('WARNING: video ad deprecated in Heyzap sdk 10');
            if (!navigator.onLine) {
                return false;
            }
            return canShow;
        },
        showVideo: function (callback, endCallback) {
            console.log('WARNING: video ad deprecated in Heyzap sdk 10');
            if (canShow) {
                window.HeyzapAds.VideoAd.show().then(function () {}, function (error) {});
            }
            onHide = endCallback;
        },
        canShowInterstitial: function () {
            if (!navigator.onLine) {
                return false;
            }
            return canShowInterstitial;
        },
        showInterstitial: function (callback, endCallback) {
            if (canShowInterstitial) {
                window.HeyzapAds.InterstitialAd.show().then(function () {}, function (error) {});
            }
            onHide = endCallback;
        }
    };
});