/**
 * Module modelled after heyzap
 * @moduleName IronSrc
 */
bento.define('ads/ironsrc', [
    'bento',
    'bento/utils',
    'bento/eventsystem',
    'modules/ironsource'
], function (
    Bento,
    Utils,
    EventSystem,
    IronSource
) {

    var canShowInterstitial = false;
    var canShowRewarded = false;
    var IronSrc = {
        canShow: function () {
            console.log('WARNING: deprecated function');
            return false;
        },
        show: function (callback, endCallback) {
            console.log('WARNING: deprecated function');
        },
        canShowRewarded: function () {
            return canShowRewarded;
        },
        showRewarded: function (callback, endCallback, tag) {
            IronSource.showRewarded(function () {
                if (endCallback) {
                    endCallback(true);
                }
                checkRewardedAvailable();
            }, function (err) {
                console.log('Rewarded error, ' + err);
                if (endCallback) {
                    endCallback(false);
                }
            }, tag);
        },
        canShowInterstitial: function () {
            return canShowInterstitial;
        },
        showInterstitial: function (callback, endCallback, tag) {
                console.log('Start interstitial')
            IronSource.showInterstitial(function () {
                console.log('Completed Interstitial')
                if (endCallback) {
                    endCallback(true);
                }
                checkInterstitialAvailable();
            }, function (err) {
                console.log('Interstitial error, ' + err);
                if (endCallback) {
                    endCallback(false);
                }
            }, tag);
        }
    };
    var checkInterstitialAvailable = function () {
        IronSource.canShowInterstitial (function () {
            canShowInterstitial = true;
        }, function (e) {
            canShowInterstitial = false;
            // try again in 5 sec
            window.setTimeout(checkInterstitialAvailable, 5000);
        });
    };
    var checkRewardedAvailable = function () {
        IronSource.canShowRewarded (function () {
            canShowRewarded = true;
        }, function (e) {
            canShowRewarded = false;
            // try again in 5 sec
            window.setTimeout(checkRewardedAvailable, 5000);
        });
    };


    checkInterstitialAvailable();
    checkRewardedAvailable();

    return IronSrc;
});