/**
 * Event listener to update coins
 */
bento.define('components/coinupdater', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    return function (settings) {
        var viewport = Bento.getViewport();
        var entity;
        var component = {
            name: 'coinUpdater',
            onCoinUpdate: function () {
                // assumes entity is a HudCoinCounter
                entity.setValue(Bento.saveState.load());
            },
            start: function (data) {
                EventSystem.on('updateCoins', this.onCoinUpdate);
            },
            destroy: function (data) {
                EventSystem.off('updateCoins', this.onCoinUpdate);
            },
            attached: function (data) {
                entity = data.entity;
            }
        };
        return component;
    };
});