/**
 * Draw page in view
 */
bento.define('components/drawinview', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    return function (settings) {
        var viewport = Bento.getViewport();
        var page;
        var component = {
            name: 'drawInView',
            attached: function (data) {
                page = data.entity;
            },
            update: function () {
                var worldPosition = page.getWorldPosition(); // <- can be optimized
                var i;
                var item;
                var items = page.getItems();
                if (worldPosition.x > viewport.x - viewport.width / 2 + 4 && worldPosition.x < viewport.x + viewport.width * 1.5 - 4) {
                    if (page.visible === false) {
                        page.visible = true;
                        // resume the cards
                        for (i = 0; i < items.length; ++i) {
                            item = items[i];
                            if (!item) {
                                continue;
                            }
                            item.updateWhenPaused = Utils.PauseLevels.TEAMEDIT;
                            // item.getComponent('draggable', function (draggable) {
                            //     draggable.activate();
                            // });
                        }
                    }
                } else {
                    if (page.visible === true) {
                        page.visible = false;
                        // pause the cards for performance
                        for (i = 0; i < items.length; ++i) {
                            item = items[i];
                            if (!item) {
                                continue;
                            }
                            item.updateWhenPaused = 0;
                            // item.getComponent('draggable', function (draggable) {
                            //     draggable.deactivate();
                            // });
                        }
                    }
                }
            }
        };
        return component;
    };
});