/**
 * Caught popup
 */
bento.define('entities/battle/caughtpopup', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'bento/canvas',
    'bento/packedimage',
    'bento/gui/counter',
    'bento/gui/clickbutton',
    'entities/battle/critter',
    'entities/card',
    'components/walk',
    'components/enemy',
    'gui/damagecounter',
    'gui/hpbar',
    'bento/gui/text',
    'entities/particles/hit',
    'entities/battle/catchpopup',
    'entities/battle/gameover',
    'gui/team/teamedit',
    'gui/combiner/combiner',
    'gui/fade',
    'gui/storydialog',
    'modules/stackblur',
    'modules/videoadtimer',
    'modules/forcedadtimer',
    'ads/heyzap',
    'modules/share/catch',
    'gui/newcritter'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Canvas,
    PackedImage,
    Counter,
    ClickButton,
    Critter,
    Card,
    Walk,
    Enemy,
    DamageCounter,
    HpBar,
    Text,
    HitParticle,
    CatchPopup,
    GameOver,
    TeamEdit,
    Combiner,
    Fade,
    StoryDialog,
    StackBlur,
    VideoAdTimer,
    ForcedAdTimer,
    HeyZap,
    ShareCatch,
    NewCritter
) {
    'use strict';
    return function (settings, onClose) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
            manager: BattleManager
            caught: Entity (frontEnemy)
        }*/
        var viewport = Bento.getViewport();
        var sawTutorial = Bento.saveState.load('sawTutorial', false);
        var showTutorial2;
        var isTutorial = false;
        var frontEnemy = settings.caught;
        var popup = new Entity({
            z: Utils.Layers.GUI + 10,
            name: 'caughtPopup',
            position: new Vector2(viewport.width / 2 + 5, -188),
            originRelative: new Vector2(0.5, 0),
            float: true,
            updateWhenPaused: Utils.PauseLevels.CAUGHT,
            components: [new Sprite({
                imageName: 'collect/caughtwindow'
            })]
        });
        var overlay = new Entity({
            z: Utils.Layers.GUI + 9,
            name: 'overlay',
            position: new Vector2(viewport.width / 2, viewport.height / 2),
            originRelative: new Vector2(0.5, 0.5),
            float: true,
            components: [new Sprite({
                imageName: 'fade'
            })]
        });
        var oldPauseLevel = Bento.objects.isPaused();
        // var buttonMap = new ClickButton({
        //     sfx: 'sfx_transition',
        //     name: 'buttonMap',
        //     image: Bento.assets.getImage('collect/buttonmap'),
        //     frameCountX: 2,
        //     frameCountY: 1,
        //     animations: {
        //         up: {
        //             frames: [0]
        //         },
        //         down: {
        //             frames: [1]
        //         }
        //     },
        //     position: new Vector2(-65, 39),
        //     updateWhenPaused: Utils.PauseLevels.CAUGHT,
        //     onClick: function () {
        //         new Fade({
        //             callback: function () {
        //                 Bento.screens.show('screens/map');
        //             }
        //         });
        //     }
        // });
        var dismiss = function () {
            // if (!canClose) {
            //     return;
            // }

            // move out
            buttonContinue.setActive(false);
            buttonTeam.setActive(false);
            buttonCombine.setActive(false);
            buttonShare.setActive(false);
            close();
        };
        var buttonTeam = new ClickButton({
            sfx: 'sfx_button',
            image: Bento.assets.getImage('map/buttonteamedit'),
            frameCountX: 2,
            frameCountY: 2,
            animations: {
                up: {
                    frames: [0]
                },
                down: {
                    frames: [1]
                },
                inactive: {
                    frames: [2]
                }
            },
            position: new Vector2(-8 + 36, 172 + 40),
            updateWhenPaused: Utils.PauseLevels.CAUGHT,
            onClick: function () {
                // go to team select screen
                var teamEdit = new TeamEdit({
                    onClose: function () {
                        setVisible(true);
                        // reload team
                        Bento.objects.get('teamPanel', function (teamPanel) {
                            teamPanel.makeTeamCritters();
                        });

                        // exit immediately
                        dismiss();
                    }
                });
                Bento.objects.attach(teamEdit);
                // make everything else invisible
                setVisible(false);
            }
        });
        var buttonCombine = new ClickButton({
            sfx: 'sfx_button',
            image: Bento.assets.getImage('map/buttoncombine'),
            frameCountX: 2,
            frameCountY: 2,
            animations: {
                up: {
                    frames: [0]
                },
                down: {
                    frames: [1]
                },
                inactive: {
                    frames: [2]
                }
            },
            position: new Vector2(-8 - 36, 172 + 40),
            updateWhenPaused: Utils.PauseLevels.CAUGHT,
            onClick: function () {
                // go to team select screen
                var teamEdit = new Combiner({
                    onClose: function () {
                        setVisible(true);
                        // reload team
                        Bento.objects.get('teamPanel', function (teamPanel) {
                            teamPanel.makeTeamCritters();
                        });

                        // exit immediately
                        dismiss();
                    }
                });
                Bento.objects.attach(teamEdit);
                // make everything else invisible
                setVisible(false);
            }
        });
        var buttonShare = new ClickButton({
            name: 'buttonShare',
            sfx: 'sfx_button',
            image: Bento.assets.getImage('gui/buttonshare'),
            frameCountX: 2,
            frameCountY: 1,
            animations: {
                up: {
                    frames: [0]
                },
                down: {
                    frames: [1]
                },
                inactive: {
                    frames: [0]
                }
            },
            position: new Vector2(-8 - viewport.width / 2 + 26, 32),
            updateWhenPaused: Utils.PauseLevels.CAUGHT,
            onClick: function () {
                var shareScore = Utils.Localization.getText('shareText2'),
                    link = Utils.getStoreLink();

                if (window.Cocoon && window.Cocoon.Share) {
                    shareScore = shareScore.replace('[LINK]', link);
                    shareScore = shareScore.replace('{NAME}', Utils.Localization.getName(frontEnemy.getProperty('id')));

                    Cocoon.Share.share({
                        message: shareScore,
                        image: ShareCatch({
                            critter: frontEnemy.getProperty('id')
                        }).getBase64()
                    }, function () {
                        // success
                        // Standard Firebase event for finding the most viral content in your app
                        Utils.Firebase.logEvent(Utils.Firebase.Events.SHARE, {
                            content_type: 'critter caught',
                            item_id: frontEnemy.getProperty('id')
                        });
                    });

                }
            }
        });
        var buttonContinue = new ClickButton({
            sfx: 'sfx_button',
            name: 'buttonContinue',
            image: Bento.assets.getImage('collect/buttoncontinue'),
            frameCountX: 3,
            frameCountY: 1,
            animations: {
                up: {
                    frames: [0]
                },
                down: {
                    frames: [1]
                },
                inactive: {
                    frames: [2]
                }
            },
            position: new Vector2(-8, 172),
            updateWhenPaused: Utils.PauseLevels.CAUGHT,
            onClick: function () {
                // new Fade({
                //     fadeIn: true,
                //     callback: function () {
                //         var i = 0;
                //         var teamCritters = Utils.getTeam();
                //         console.log('heal critters');
                //         for (i = 0; i < teamCritters.length; ++i) {
                //             if (teamCritters[i]) {
                //                 // TEMP heal critters
                //                 teamCritters[i].currentHp = teamCritters[i].hp;
                //             }
                //         }
                //         Utils.saveCritters();

                //         Bento.screens.show('screens/battle');
                //     }
                // });

                // tutorial?
                /*if (!sawTutorial) {
                    isTutorial = true;
                    tutorial();
                } else if (showTutorial2) {
                    isTutorial = true;
                    tutorial2();
                } else {
                    dismiss();
                }*/

                // tutorials deprecated, just close the popup
                dismiss();
            }
        });
        var crittersCaught = Bento.saveState.load('crittersCaught', 0);
        var caughtCritter;
        var tutorialStep = 0;
        var canClose = false;
        var center = new Vector2(-8, 104);
        var getHand = function () {
            return new Entity({
                name: 'hand',
                position: new Vector2(0, 8),
                originRelative: new Vector2(0.5, 0),
                updateWhenPaused: Utils.PauseLevels.CAUGHT,
                components: [new Sprite({
                    imageName: 'map/hand'
                })]
            }).attach({
                update: function (data) {
                    var hand = data.entity;
                    hand.position.y = 4 + 4 * Math.abs(Math.sin(hand.timer / 20));
                }
            });
        };
        var tut1 = new ClickButton({
            sfx: 'sfx_button',
            image: Bento.assets.getImage('map/buttonteamedit'),
            frameCountX: 2,
            frameCountY: 2,
            animations: {
                up: {
                    frames: [0]
                },
                down: {
                    frames: [1]
                },
                inactive: {
                    frames: [2]
                }
            },
            position: center.add(new Vector2(0, 10)),
            updateWhenPaused: Utils.PauseLevels.CAUGHT,
            onClick: function () {
                // go to team select screen
                var teamEdit = new TeamEdit({
                    onClose: function () {
                        var team = Utils.getTeam();
                        var teamCount = (team[0] !== null) + (team[1] !== null) + (team[2] !== null);
                        setVisible(true);

                        // reload team
                        Bento.objects.get('teamPanel', function (teamPanel) {
                            teamPanel.makeTeamCritters();
                        });
                        // did the user really put a critter in their team?
                        if (teamCount > 1) {
                            buttonContinue.setActive(true);
                            tutorial();
                        }
                    }
                });
                Bento.objects.attach(teamEdit);
                // make everything else invisible
                setVisible(false);
            }
        });
        var tut2 = new ClickButton({
            sfx: 'sfx_button',
            image: Bento.assets.getImage('map/buttoncombine'),
            frameCountX: 2,
            frameCountY: 2,
            animations: {
                up: {
                    frames: [0]
                },
                down: {
                    frames: [1]
                },
                inactive: {
                    frames: [2]
                }
            },
            position: center.add(new Vector2(0, 10)),
            updateWhenPaused: Utils.PauseLevels.CAUGHT,
            onClick: function () {
                // go to team select screen
                var combiner = new Combiner({
                    onClose: function () {
                        var combineCount = Bento.saveState.load('combineCount', 0);
                        setVisible(true);

                        // reload team
                        Bento.objects.get('teamPanel', function (teamPanel) {
                            teamPanel.makeTeamCritters();
                        });
                        // did the user really combine critters?
                        if (combineCount > 0) {
                            buttonContinue.setActive(true);
                            tutorial2();
                        }
                    }
                });
                Bento.objects.attach(combiner);
                // make everything else invisible
                setVisible(false);
            }
        });
        var tutorial = function () {
            if (tutorialStep === 0) {
                popup.remove(caughtCritter);
                topText.setText(Utils.Localization.getText('teamTutorial')[0]);
                // popup.attach(tut1);
            }
            if (tutorialStep === 1) {
                topText.setText(Utils.Localization.getText('teamTutorial')[1]);
                buttonContinue.setActive(false);
                popup.attach(tut1.attach(getHand()));
            }
            if (tutorialStep === 2) {
                popup.remove(tut1);
                topText.setText(Utils.Localization.getText('teamTutorial')[2]);
            }
            if (tutorialStep === 3) {
                topText.setText(Utils.Localization.getText('teamTutorial')[3]);
                Bento.saveState.save('sawTutorial', true);
                Utils.Analytics.event('Game', 'sawTutorial');
                Utils.Firebase.logEvent('sawTutorial');
                buttonContinue.setActive(false);
                close();
            }
            // if (tutorialStep === 1) {
            //     popup.remove(tut1);
            //     topText.setText('\nOr combine your critters to make a brand new one!');
            //     popup.attach(tut2);
            // }
            // if (tutorialStep === 2) {
            //     popup.remove(tut2);
            //     topText.setText('\nDiscover poweful critters\n\n...\n\nAnd conquer the universe!');
            // }
            // if (tutorialStep === 3) {
            //     topText.setText('Good luck!');
            //     buttonContinue.setActive(false);
            //     close();
            // }
            tutorialStep += 1;
        };
        var tutorial2 = function () {
            if (tutorialStep === 0) {
                popup.remove(caughtCritter);
                topText.setText(Utils.Localization.getText('combineTutorial')[0]);
            }
            if (tutorialStep === 1) {
                topText.setText(Utils.Localization.getText('combineTutorial')[1]);
                buttonContinue.setActive(false);
                popup.attach(tut2.attach(getHand()));
            }
            if (tutorialStep === 2) {
                popup.remove(tut2);
                topText.setText(Utils.Localization.getText('combineTutorial')[2]);
            }
            if (tutorialStep === 3) {
                topText.setText(Utils.Localization.getText('combineTutorial')[3]);
                Bento.saveState.save('sawTutorial2', true);
                Utils.Analytics.event('Game', 'sawTutorial2');
                buttonContinue.setActive(false);
                close();
            }

            tutorialStep += 1;
        };
        var topText = new Text({
            position: new Vector2(-4, 60),
            text: Utils.Localization.getName(frontEnemy.getProperty('id')),
            font: 'volter',
            fontSize: 9,
            fontSettings: Utils.FontSettings.get('font'),
            fontColor: '#ffffff',
            align: 'center',
            ySpacing: 2,
            maxWidth: 140,
            linebreaks: true
        });
        // 'new!' animation from Nom Cat
        var newText = new NewCritter({
            position: new Vector2(10, 142)
        });
        var dropCritter = function () {
            var drop = function () {
                caughtCritter.position.x = -6;
                new Tween({
                    from: 0,
                    to: 144,
                    'in': 40,
                    ease: 'quadratic',
                    updateWhenPaused: Utils.PauseLevels.CAUGHT,
                    'do': function (v, t) {
                        caughtCritter.position.y = v;
                    },
                    onComplete: bounce
                });
            };
            var bounce = function () {
                Bento.audio.playSound('sfx_new_critter');
                // bounce
                new Tween({
                    from: 0,
                    to: 1,
                    'in': 60,
                    ease: 'elastic',
                    alpha: -6,
                    beta: 3,
                    updateWhenPaused: Utils.PauseLevels.CAUGHT,
                    'do': function (v, t) {
                        caughtCritter.scale.x = 1 + 0.2 - 0.2 * v;
                        caughtCritter.scale.y = 1 - 0.2 + 0.2 * v;
                    },
                    onComplete: lighten
                });
            };
            var lighten = function () {
                var screen = Bento.screens.getCurrentScreen();
                if (screen.name === 'screens/worldmap' && !Bento.audio.isPlayingMusic(Utils.worldMap.planetData.bgm)) {
                    Bento.audio.stopAllMusic();
                    Bento.audio.playMusic(Utils.worldMap.planetData.bgm);
                }

                canClose = true;

                if (!Utils.DGG_DEMO && HeyZap.canShow() && ForcedAdTimer.canPlay()) {
                    // new StoryDialog({
                    //     text: Utils.Localization.getText('preForcedAd'),
                    //     onComplete: {
                    //         "0": showAd
                    //     }
                    // });
                    // console.log('show forced ad');
                    // showAd();
                }

                // critterOverlay.getComponent('opacity', function (component) {
                //     critterOverlay.visible = true;
                //     component.setOpacity(0);
                //     new Tween({
                //         from: 0,
                //         to: 1,
                //         'in': 30,
                //         ease: 'linear',
                //         'do': function (v, t) {
                //             component.setOpacity(v);
                //         },
                //         onComplete: function () {
                //             popup.remove(caughtCritter);
                //         }
                //     });
                // });
            };
            caughtCritter = new Critter(Utils.clone(frontEnemy.getProperties()));
            var caughtCritterOverlay = new Entity({
                name: 'critterOverlay',
                position: new Vector2(0, 0),
                originRelative: new Vector2(0.5, 1),
                components: [new Sprite({
                    imageName: 'creatures/' + caughtCritter.getProperty('id')
                })]
            });
            var critterOverlay = new Canvas({
                position: new Vector2(0, 0),
                width: caughtCritter.dimension.width,
                height: caughtCritter.dimension.height,
                originRelative: new Vector2(0.5, 1)
            });
            caughtCritter.attach(critterOverlay);
            critterOverlay.visible = false;
            // draw white critter overlay
            critterOverlay.attach(caughtCritterOverlay);
            critterOverlay.attach({
                draw: function () {
                    var context = critterOverlay.getContext();
                    var dimension = caughtCritter.dimension;
                    // draw white overlay inside
                    context.globalCompositeOperation = 'source-in';
                    context.fillStyle = 'white';
                    context.fillRect(-dimension.width / 2, -dimension.height, dimension.width, dimension.height);
                }
            });
            popup.attach(caughtCritter);
            addOverlay();
            drop();
        };
        var addOverlay = function () {
            var popupOverlay = new Entity({
                name: 'popupOverlay',
                position: new Vector2(-5, 28),
                originRelative: new Vector2(0.5, 0.5),
                components: [new Sprite({
                    imageName: 'collect/overlay'
                })]
            });
            var extended = new Entity({
                name: 'caughtPopup',
                position: new Vector2(-1, -popupOverlay.dimension.height / 2),
                originRelative: new Vector2(0.5, 1),
                components: [new Sprite({
                    imageName: 'collect/overlayextended'
                })]
            });
            popup.attach(popupOverlay);
            popupOverlay.attach(extended);

        };
        var close = function () {
            new Tween({
                from: 1,
                to: 0,
                'in': 30,
                ease: 'linear',
                updateWhenPaused: Utils.PauseLevels.CAUGHT,
                'do': function (v, t) {
                    blurredBackground.alpha = (v);
                },
                onComplete: function () {

                }
            });
            new Tween({
                to: -188,
                from: -20,
                'in': 30,
                ease: 'easeInBack',
                'do': function (v, t) {
                    popup.position.y = v;
                },
                updateWhenPaused: Utils.PauseLevels.CAUGHT,
                onComplete: function () {
                    Bento.objects.remove(blurredBackground);
                    Bento.objects.remove(overlay);
                    Bento.objects.remove(popup);
                    Bento.objects.pause(oldPauseLevel);

                    // quick fix for pause bug:
                    // user might click the shop before the caughtpopup opens
                    if (oldPauseLevel === Utils.PauseLevels.SHOP) {
                        Bento.objects.resume();
                    }

                    if (settings.onClose) {
                        settings.onClose(watchedAd);
                    }
                    if (onClose) {
                        onClose(watchedAd);
                    }

                    if (
                        Bento.saveState.load('showObjective1', false) === false &&
                        Bento.saveState.load('firstBossBattle', false) === false &&
                        Bento.saveState.load('sawTutorial2', false)
                    ) {
                        new StoryDialog({
                            text: Utils.Localization.getText('findBoss'),
                            attachments: {
                                "2": new Entity({
                                    position: new Vector2(0, 12),
                                    originRelative: new Vector2(0.5, 0.5),
                                    components: [
                                        new Sprite({
                                            image: Bento.assets.getImage('worldmap/tokenicon'),
                                        })
                                    ]
                                })
                            },
                            onClose: function () {
                                Bento.saveState.save('showObjective1', true);
                            }
                        });
                    }
                }
            });
        };
        var watchedAd = false;
        var showAd = function () {
            var oldPauseLevelAd = Bento.objects.isPaused();
            var onClosedAd = function (success) {
                Bento.objects.pause(oldPauseLevelAd);
                // reset video timer
                if (success) {
                    ForcedAdTimer.reset();
                }
            };
            var totalAdsWatched = Bento.saveState.load('totalAdsWatched', 0);
            var forcedAdsWatched = Bento.saveState.load('forcedAdsWatched', 0);
            var coinAdsWatched = Bento.saveState.load('coinAdsWatched', 0);
            var rerollAdsWatched = Bento.saveState.load('rerollAdsWatched', 0);

            Bento.objects.pause(Utils.PauseLevels.VIDEOAD);
            //Utils.EveryPlay.pause();

            // watch ad
            if (HeyZap.canShowInterstitial()) {
                Bento.audio.muteMusic(true);

                ++totalAdsWatched;
                ++forcedAdsWatched;

                // user started watching ad
                Utils.Analytics.event('Ads', 'startForcedAd_' + forcedAdsWatched);
                Utils.Analytics.event('Ads', 'startTotalAd_' + totalAdsWatched);

                HeyZap.showInterstitial(function () {}, function () {
                    // user finished watching ad
                    Utils.Analytics.event('Ads', 'finishForcedAd_' + forcedAdsWatched);
                    Utils.Analytics.event('Ads', 'finishTotalAd_' + totalAdsWatched);

                    Utils.Analytics.event('Ads', 'forced_' + forcedAdsWatched);
                    Utils.Analytics.event('Ads', 'total_' + totalAdsWatched);

                    if (window.tenjin && Utils.isNativeIos()) {
                        window.tenjin.sendEvent('interstitialAd', function () {}, function () {});
                    }


                    Utils.Firebase.logEvent('watched_forced_ad', {
                        value: 1,
                        forced_ads_watched: forcedAdsWatched,
                        coin_ads_watched: coinAdsWatched,
                        total_ads_watched: totalAdsWatched,
                        reroll_ads_watched: rerollAdsWatched
                    });
                    Utils.Firebase.logEvent('watched_ad', {
                        value: 1,
                        ad_type: 'forced',
                        forced_ads_watched: forcedAdsWatched,
                        coin_ads_watched: coinAdsWatched,
                        total_ads_watched: totalAdsWatched,
                        reroll_ads_watched: rerollAdsWatched
                    });

                    Bento.saveState.save('totalAdsWatched', totalAdsWatched);
                    Bento.saveState.save('forcedAdsWatched', forcedAdsWatched);

                    Bento.audio.muteMusic(Bento.saveState.load('muteMusic', false), true);
                    bento.require(['audia'], function (Audia) {
                        var audioContext = Audia.audioContext;
                        if (audioContext && audioContext.state === 'suspended') {
                            audioContext.resume();
                        }
                    });
                    onClosedAd(true);
                    Utils.Analytics.event('UI', 'forcedAd');
                    Utils.GooglePlay.submitEvent('CgkI--zjoo8UEAIQAw', 1);
                    watchedAd = true;
                    //Utils.EveryPlay.resume();
                });
            } else {
                if (Utils.isCocoonJS()) {
                    // alert('Sorry, no ad available');
                    onClosedAd(false);
                } else {
                    // simulate watching
                    window.alert('You are now watching an ad.');
                    onClosedAd(true);
                }
            }
        };
        var checkTutorial2 = function () {
            var total = Bento.saveState.load('combineCount', 0);

            if (Bento.saveState.load('sawTutorial2', false)) {
                return;
            }

            if (Bento.saveState.load('sawTutorial', false) === true && total === 0) {
                showTutorial2 = true;
            } else if (total > 0) {
                Bento.saveState.save('sawTutorial2', true);
            }
        };
        var setVisible = function (value) {
            Bento.objects.get('mode7', function (entity) {
                entity.visible = value;
            });
            Bento.objects.get('player', function (entity) {
                entity.visible = value;
            });
            Bento.objects.getByFamily('triggers', function (array) {
                Utils.forEach(array, function (item, i, l, breakLoop) {
                    item.visible = value;
                });
            });
        };
        var blurredBackground;
        var blurredSprite;
        var blur = function () {
            var canvas = Utils.lastScreenshot;
            if (!canvas) {
                return;
            }

            // blur snapshot
            StackBlur.canvasRGBA(canvas, 0, 0, canvas.width, canvas.height, 10);

            blurredSprite = new Sprite({
                image: new PackedImage(canvas)
            });
            blurredBackground = new Entity({
                z: Utils.Layers.GUI + 9,
                name: 'blur',
                position: new Vector2(viewport.width / 2, viewport.height / 2),
                originRelative: new Vector2(0.5, 0.5),
                float: true,
                components: [
                    blurredSprite
                ]
            });
            // fit to screen
            blurredBackground.scale.x = viewport.width / blurredBackground.dimension.width;
            blurredBackground.scale.y = viewport.height / blurredBackground.dimension.height;

            // Bento.objects.attach(blurredBackground);
        };

        overlay.alpha = 0.75;

        blur();
        // popup.attach(buttonMap);
        popup.attach(buttonContinue);
        // popup.attach(buttonTeam);
        popup.attach(topText);
        if (settings.caught.newCritter) {
            popup.attach(newText);
        }

        // show tutorial 2: tutorial 1 done, but never combined
        checkTutorial2();

        Bento.objects.attach(popup);
        Bento.objects.attach(overlay);
        new Tween({
            from: -188,
            to: -20,
            'in': 30,
            ease: 'easeOutBack',
            'do': function (v, t) {
                popup.position.y = v;
            },
            updateWhenPaused: Utils.PauseLevels.CAUGHT,
            onComplete: dropCritter
        });

        Bento.objects.pause(Utils.PauseLevels.CAUGHT);

        // saw all tutorials? attach combine and teamedit
        if (Bento.saveState.load('sawTutorial2', false)) {
            popup.attach(buttonTeam);
            popup.attach(buttonCombine);
            // popup.attach(buttonShare);

            // hint to combine button after tutorials
            if (Bento.saveState.load('hintCombine', false) === false) {
                //buttonCombine.attach(getHand());
                Bento.saveState.save('hintCombine', true);
            }
        }
        addOverlay();

        crittersCaught += 1;
        Bento.saveState.save('crittersCaught', crittersCaught);

        if (
            Bento.saveState.load('sawTutorial2', false) &&
            !Utils.DGG_DEMO &&
            Bento.saveState.load('removeAds', false) === false &&
            Bento.saveState.load('firstBossBattle', false) &&
            !Bento.saveState.load('highSpender', false) && // disable forced ads for high spenders
            ForcedAdTimer.canPlay()
        ) {
            // if (!Utils.DGG_DEMO && Bento.saveState.load('sawTutorial2', false) && crittersCaught > 5 && crittersCaught % 5 === 0) {
            console.log('show forced ad');
            if (HeyZap.canShowInterstitial()) {
                showAd();
            } else {
                console.log('No ad available!');
            }
        }

        return popup;
    };
});