/**
 * Death particle
 */
bento.define('entities/particles/death', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'entities/effect'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Effect
) {
    'use strict';
    return function (settings) {
        var entity = new Effect({
            position: settings.position,
            originRelative: new Vector2(0.5, 1),
            sprite: new Sprite({
                imageName: 'battle/effects/deadpoof',
                frameCountX: 3,
                frameCountY: 3,
                animations: {
                    'default': {
                        speed: 0.2,
                        frames: [0, 1, 2, 3, 4, 5, 6, 7, 8]
                    }
                }
            })
        });
        Utils.screenShake(6, 10);
        return entity;
    };
});