/**
 * Getting hit particle
 */
bento.define('entities/particles/hit', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'entities/effect'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Effect
) {
    'use strict';
    return function (settings) {
        return new Effect({
            position: settings.position,
            sprite: new Sprite({
                imageName: 'battle/effects/hitbump',
                frameCountX: 3,
                frameCountY: 2,
                animations: {
                    'default': {
                        speed: 0.2,
                        frames: [0, 1, 2, 3, 4, 5]
                    }
                }
            })
        });
    };
});