/**
 * Module description
 */
bento.define('entities/worldmap/zaspirirock', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'components/depth',
    'components/sort'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    ClickButton,
    Counter,
    Text,
    EventSystem,
    Utils,
    Tween,
    Depth,
    Sort
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var image = settings.tiled.tile.image || 'worldmap/zaspiri/rock0';
        var sprite = new Sprite({
            imageName: image
        });
        var depth = new Depth({});
        var sort = new Sort({});
        var behavior = {
            start: function () {
                // entity.position.y += 16 * 3;
            }
        };
        var entity = new Entity({
            z: 1,
            name: 'carrot',
            position: settings.position || new Vector2(0, 0),
            originRelative: new Vector2(0.5, 1),
            updateWhenPaused: 0,
            family: [''],
            components: [
                sprite,
                sort,
                depth
            ]
        });
        // entity.origin.y -= 16 * 4;
        return entity;
    };
});