/**
 * Coin counter
 */
bento.define('gui/coincounter', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    ClickButton,
    Counter,
    Text,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
            z: Number
            float: Boolean
            aligb: String
            imageName: String // which image to use for counters
        }*/
        var viewport = Bento.getViewport();
        var paddings = {
            'gui/numberswhiteoutline': 1
        };
        var imageName = settings.imageName || 'gui/numberswhiteoutline';
        var counter = new Counter({
            z: settings.z || 0,
            name: settings.name || 'counter',
            image: Bento.assets.getImage(imageName),
            frameWidth: 8,
            frameHeight: 8,
            padding: paddings[imageName],
            spacing: new Vector2(-3, 0),
            position: settings.position || new Vector2(0, 0),
            align: settings.align || 'left',
            float: settings.float,
            family: ['coinCounters'],
            animations: {
                '0': {
                    frames: [0]
                },
                '1': {
                    frames: [1]
                },
                '2': {
                    frames: [2]
                },
                '3': {
                    frames: [3]
                },
                '4': {
                    frames: [4]
                },
                '5': {
                    frames: [5]
                },
                '6': {
                    frames: [6]
                },
                '7': {
                    frames: [7]
                },
                '8': {
                    frames: [8]
                },
                '9': {
                    frames: [9]
                },
                '-': {
                    frames: [10]
                },
                'A': {
                    frames: [11]
                },
                'H': {
                    frames: [12]
                },
                '*': {
                    frames: [13]
                },
                '$': {
                    frames: [15]
                },
                ':': {
                    frames: [16]
                },
                '/': {
                    frames: [17]
                },
                ' ': {
                    frames: [18]
                }
            },
            // TODO price
            value: settings.value || 0
        });
        return counter;
    };
});