/**
 * HP bar in cards and above enemies
 */
bento.define('gui/hpbar', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'gui/horizontalbar'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Tween,
    HorizontalBar
) {
    'use strict';
    return function (settings, battle) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var imageNameExtra = battle ? '-battle' : '';
        var hpBarBack = new Entity({
            z: Utils.Layers.GUI,
            name: 'hpBar',
            position: new Vector2(-23, 12),
            family: [''],
            components: [new Sprite({
                imageName: 'gui/hpbar-back' + imageNameExtra,
            })]
        });
        var hpBar = new HorizontalBar({
            leftImageName: 'gui/hpbar-left' + imageNameExtra,
            middleImageName: 'gui/hpbar-middle' + imageNameExtra,
            rightImageName: 'gui/hpbar-right' + imageNameExtra,
            position: new Vector2(1, 2),
            totalWidth: battle ? 29 : 41,
            value: settings.currentHp,
            maxValue: settings.hp
        });
        hpBarBack.attach(hpBar);

        hpBarBack.extend({
            setValue: hpBar.setValue,
            addValue: hpBar.addValue
        });

        return hpBarBack;
    };
});