bento.define('gui/newcritter', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        settings = settings || {};
        var viewport = Bento.getViewport();
        var screenMid = new Vector2(viewport.width / 2, viewport.height / 2);
        var sprite = settings.small ?
            new Sprite({
                imageName: 'gui/newcrittersmall'
            }) :
            new Sprite({
                imageName: 'gui/newcritter',
                frameCountX: 6,
                frameCountY: 1,
                animations: {
                    'default': {
                        speed: 0.2,
                        frames: [0, 1, 2, 3, 4, 5]
                    }
                }
            });

        var entity = new Entity({
            name: 'newCritterText',
            position: settings.position || new Vector2(0, 0),
            originRelative: new Vector2(0, 0),
            components: [
                sprite
            ]
        });

        return entity;
    };
});