/**
 * Module description
 */
bento.define('gui/pausebutton', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'bento/gui/text'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Text
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var entity = new Text({
            z: Utils.Layers.GUI,
            position: new Vector2(0, 0),
            text: 'Pause',
            font: 'font',
            fontSize: 16,
            fontColor: '#ffffff',
            align: 'left',
            textBaseline: 'top',
            margin: new Vector2(0, 0),
            lineWidth: 1,
            strokeStyle: '#000000',
            pixelStroke: true // workaround for Cocoon bug
        });

        entity.float = true;
        entity.updateWhenPaused = Utils.PauseLevel.ALWAYS;
        entity.attach(new Clickable({
            onClick: function () {
                if (Bento.objects.isPaused() === Utils.PauseLevel.ALWAYS) {
                    Bento.objects.resume();
                } else {
                    Bento.objects.pause(Utils.PauseLevel.ALWAYS);
                }
            }
        }));

        return entity;
    };
});