/**
 * Wrapper for https://github.com/ohh2ahh/AppAvailability
 * Checks for available url schemes and caches the result
 */
bento.define('modules/appavailability', [], function () {
    'use strict';
    var available = {};
    var checkLuckyKatLinks = function () {
        var i, number;
        for (i = 0; i < 100; ++i) {
            number = ("00" + i).slice(-2);
            check('lk' + number + '://', 'lk' + number);
        }
    };
    var check = function (url, name) {
        window.appAvailability.check(
            url, // URI Scheme
            function () { // Success callback
                available[name] = true;
            },
            function () { // Error callback

            }
        );
    };
    var isNativeIos = function () {
        if (navigator.isCocoonJS && window.Cocoon && window.Cocoon.getPlatform() === 'ios') {
            return true;
        }
        return false;
    };
    var isNativeAndroid = function () {
        var platform;
        if (navigator.isCocoonJS && window.Cocoon) {
            platform = window.Cocoon.getPlatform();
            if (platform === 'android' || platform === 'amazon') {
                return true;
            }
        }
        return false;
    };
    if (!window.appAvailability) {
        return available;
    }

    if (isNativeIos()) {
        check('twitter://', 'twitter');
        check('fb://', 'facebook');
        check('weibo://', 'weibo');
        check('instagram://', 'instagram');
        check('roadwarriors://', 'roadwarriors');
        checkLuckyKatLinks();
    } else if (isNativeAndroid()) {
        // android has the ability to look which apps are installed
        check('com.twitter.android', 'twitter');
        check('com.facebook.katana', 'facebook');
        check('com.tencent.weibo', 'weibo');
        check('com.instagram.android', 'instagram');
        check('com.luckykat.roadwarriors', 'roadwarriors');
    }
    return available;

});