/**
 * When 'space' is pressed, testsound is played. For stupid artists (Maxo and Diane mostly) :p
 */
bento.define('modules/soundtester', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    var viewport = Bento.getViewport();
    var screenMid = new Vector2(viewport.width / 2, viewport.height / 2);
    var sound = 'sfx_testsound';
    var hold = 0;
    var module = {
        init: function () {
            Bento.objects.attach({
                global: true,
                updateWhenPaused: 0,
                update: function () {
                    if (Bento.input.isKeyDown('space')) {
                        ++hold;
                    } else {
                        hold = 0;
                    }
                    if (hold === 1) {
                        Bento.audio.playSound(sound, false, null, true);
                    }
                }
            });
        }
    };

    return module;
});