/**
 * Safe wrapper for TapticEngine.js
 * https://github.com/EddyVerbruggen/cordova-plugin-taptic-engine/blob/master/www/TapticEngine.js
 */
bento.define('modules/tapticengine', [
    'bento/utils'
], function (
    Utils
) {
    'use strict';
    var nothing = function () {};
    var initUnofficial = function () {
        console.log('TapticEngine: Swap official with unoficial API');
        window.TapticEngine.selection = window.TapticEngine.unofficial.weakBoom;
        window.TapticEngine.notification = window.TapticEngine.unofficial.burst;
        window.TapticEngine.impact = function (data) {
            if (!data) {
                return;
            }
            if (data.style === 'heavy') {
                window.TapticEngine.unofficial.strongBoom();
            }
            if (data.style === 'medium') {
                window.TapticEngine.unofficial.strongBoom();
            }
            if (data.style === 'light') {
                window.TapticEngine.unofficial.weakBoom();
            }
        };
    };
    var module = {
        unofficial: {
            weakBoom: nothing,
            strongBoom: nothing,
            burst: nothing
        },
        notification: nothing,
        selection: nothing,
        impact: nothing,
        gestureSelectionStart: nothing,
        gestureSelectionChanged: nothing,
        gestureSelectionEnd: nothing,
        initUnofficial: nothing
    };
    var isNativeAndroid = function () {
        var platform;
        if (navigator.isCocoonJS) {
            platform = window.Cocoon.getPlatform();
            if (platform === 'android' || platform === 'amazon') {
                return true;
            }
        }
        return false;
    };

    console.log('init taptic engine');

    if (!window.TapticEngine || isNativeAndroid()) {
        console.log('WARNING: cordova plugin for TapticEngine not found.');
        return module;
    }

    window.TapticEngine.initUnofficial = initUnofficial;
    window.TapticEngine.emptyModule = {
        unofficial: {
            weakBoom: nothing,
            strongBoom: nothing,
            burst: nothing
        },
        notification: nothing,
        selection: nothing,
        impact: nothing,
        gestureSelectionStart: nothing,
        gestureSelectionChanged: nothing,
        gestureSelectionEnd: nothing,
        initUnofficial: nothing
    };

    return window.TapticEngine;
});