/**
 * Screen where player can combine monsters
 */
bento.define('screens/combiner', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'bento/screen',
    'bento/gui/clickbutton',
    'components/debug',
    'components/draggable',
    'components/droptarget',
    'gui/combiner/combiner'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Screen,
    ClickButton,
    Debug,
    Draggable,
    DropTarget,
    Combiner
) {
    'use strict';
    var onShow = function () {
        /* Screen starts here */
        var combiner = new Combiner({
            onClose: function () {
                Bento.screens.show('screens/map');
            }
        });
        Bento.objects.attach(combiner);
    };

    return new Screen({
        onShow: onShow
    });
});