/**
 * A screen that only shows the team edit
 */
bento.define('screens/teamedit', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/screen',
    'bento/tween',
    'gui/team/teamedit'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    Utils,
    Screen,
    Tween,
    TeamEdit
) {
    'use strict';
    var onShow = function () {
        /* Screen starts here */
        var viewport = Bento.getViewport();
        var teamEdit = new TeamEdit({
            onClose: function () {
                Bento.screens.show('screens/map');
            }
        });
        Bento.objects.attach(teamEdit);
    };

    return new Screen({
        onShow: onShow
    });
});