bento.define('singletons/analytics', [
    'singletons/googleanalytics',
    'bento'
], function (
    GoogleAnalytics,
    Bento
) {
    'use strict';
    var userId = 'unidentified',
        sessionId = Date.now().toString(),
        // serverId = 'UA-59807613-8',
        analytics = {
            init: function (trackingId) {
                // don't send analytics during development
                if (Bento.isDev()) {
                    console.log('Google Analytics not initialized because dev mode is on');
                    return;
                }
                // init plugin
                GoogleAnalytics.setUserId(userId);

                // if (window.facebookConnectPlugin) {
                //     // https://github.com/Wizcorp/phonegap-facebook-plugin/issues/877#issuecomment-74889551
                //     window.facebookConnectPlugin.logEvent('fb_mobile_activate_app');
                // }
            },
            event: function (category, action, value, label) {
                if (!navigator.onLine || !navigator.isCocoonJS) {
                    return;
                }
                // send to googleanalytics plugin
                GoogleAnalytics.trackEvent(category, action, label, value);

                // facebook plugin
                // if (window.facebookConnectPlugin) {
                //     window.facebookConnectPlugin.logEvent(action, {
                //         category: category,
                //         action: action,
                //         value: value,
                //         label: label
                //     }, value, function () {
                //         // console.log('fb event logged:' + action);
                //     }, function () {});
                // }
            },
            trackPurchase: function (id, name, sku, category, price, quantity, currencyCode) {
                GoogleAnalytics.addTransactionItem(id, name, sku, category, price, quantity, currencyCode);
            },
            trackView: function (name) {
                GoogleAnalytics.trackView(name);
            }
        };
    if (navigator.isCocoonJS && window.Cocoon && window.Cocoon.Device) {
        userId = window.Cocoon.Device.getDeviceId();
    }
    return analytics;
});