bento.define('singletons/cocoon', [], function () {
    var cocoon = {
        share: function () {},
        openUrl: function (url) {
            console.log('Opening url: ' + url);
            if (window.cordova && window.cordova.InAppBrowser) {
                window.cordova.InAppBrowser.open(url, '_system');
            } else {
                window.open(url, '_blank');
            }
        },
        setAntiAlias: function (bool) {
            if (window.Cocoon) {
                window.Cocoon.Utils.setAntialias(bool);
            };
        },
        prompt: function (settings, callbacks) {
            if (window.Cocoon) {
                window.Cocoon.Dialog.prompt(settings, callbacks);
            } else {
                var answer = window.prompt(settings.message);
                if (callbacks && callbacks.success) {
                    callbacks.success(answer);
                }
            }
        },
        getDeviceId: function () {
            if (window.device) {
                userId = window.device.uuid;
            } else if (navigator.isCocoonJS && window.Cocoon && window.Cocoon.Device) {
                userId = window.Cocoon.Device.getDeviceId();
            }
            return 'unknown';
        }
    };

    return cocoon;
});