bento.define('singletons/fontsettings', [
    'singletons/localization'
], function (
    Localization
) {
    'use strict';
    var fontSettings = {
            'font-en': {
                font: 'volter',
                fontColor: '#fff',
                fontSize: 9,
                centerByCanvas: true
            },
            'font-ja': {
                font: 'japanese',
                fontColor: '#fff',
                fontSize: 10
            },
            'font-zh': {
                font: 'chinese',
                fontColor: '#fff',
                fontSize: 12
            },
            'font-zt': {
                font: 'chintrad',
                fontColor: '#fff',
                fontSize: 12
            },
            'font-ko': {
                font: 'bmhanna',
                fontColor: '#fff',
                fontSize: 10
            },
            'font-ru': {
                font: 'adbxtra',
                fontColor: '#fff',
                fontSize: 9
            }
        },
        getFontLang = function () {
            // returns a language code for every language that has a different font setting
            if (Localization.getLanguage() === 'zh' ||
                Localization.getLanguage() === 'zt' ||
                Localization.getLanguage() === 'ko' ||
                Localization.getLanguage() === 'ru' ||
                Localization.getLanguage() === 'ja') {
                return Localization.getLanguage();
            } else {
                return 'en';
            }
        };

    return {
        get: function (name) {
            // name = font, fontLarge, fontStroked etc.
            return fontSettings[name + '-' + getFontLang()];
        }
    };

});