bento.define('singletons/gamecenter', [], function () {
    'use strict';
    var device = null,
        loggedIn = false,
        isLoggedIn = function () {
            return loggedIn;
        },
        nothing = function () {
            return;
        },
        login = function (callback) {

            Cocoon.Social.GameCenter.login(function (response, error) {
                if (error) {
                    // alert(error);
                    console.log('GC error', error.message);
                    return;
                } else {
                    console.log('GC response', response);
                }
                loggedIn = true;
            });
        },
        post = function (score, leaderboardId, callback) {
            if (!loggedIn) {
                return;
            }
            var socialService = Cocoon.Social.GameCenter.getSocialInterface();
            socialService.submitScore(score, callback, {
                leaderboardID: leaderboardId
            });

            // var scoreGC = new Cocoon.Social.GameCenter.Score(score, leaderboardId);
            // Cocoon.Social.GameCenter.submitScore(scoreGC, callback);
        },
        show = function (callback, id) {
            Cocoon.Social.GameCenter.showLeaderboards(nothing, {
                identifier: id,
                category: id
            });
        },
        postAchievement = function (id, callback) {
            var socialService = Cocoon.Social.GameCenter.getSocialInterface();
            socialService.submitAchievement(id, function (response) {
                if (callback) {
                    callback();
                }
            });
        },
        showAchievement = function (callback) {
            Cocoon.Social.GameCenter.showAchievements(callback);
        };

    // ios?
    if (
        navigator.isCocoonJS && 
        window.Cocoon && 
        window.Cocoon.Social && 
        window.Cocoon.Social.GameCenter && 
        window.Cocoon.getPlatform() === 'ios'
    ) {
        return {
            isLoggedIn: isLoggedIn,
            login: login,
            post: post,
            show: show,
            postAchievement: postAchievement,
            showAchievement: showAchievement
        };
    } else {
        return {
            isLoggedIn: isLoggedIn,
            login: nothing,
            post: nothing,
            show: nothing,
            postAchievement: nothing,
            showAchievement: nothing
        };
    }
});