bento.define('singletons/googleanalytics', ['bento'], function (Bento) {
    'use strict';
    var nothing = function () {},
        userId = '';

    if (!window.ga || Bento.isDev()) {
        console.log('Google Analytics plugin not initialized');
        return {
            trackView: nothing,
            trackEvent: nothing,
            addTransactionItem: nothing,
            addCustomDimension: nothing,
            setUserId: nothing
        };
    } else {

    }

    // start
    if (navigator.isCocoonJS && window.Cocoon.getPlatform() === 'android') {
        window.ga.startTrackerWithId('UA-59807613-8');
    } else if (navigator.isCocoonJS && window.Cocoon.getPlatform() === 'ios') {
        window.ga.startTrackerWithId('UA-59807613-9');
    }

    return {
        trackView: function (name) {
            window.ga.trackView(name);
        },
        trackEvent: function (category, action, label, value) {
            window.ga.trackEvent(category, action, label, value);
        },
        addTransactionItem: function (id, name, sku, category, price, quantity, currencyCode) {
            window.ga.addTransactionItem(id, name, sku, category, price, quantity, currencyCode);
        },
        addCustomDimension: function (key, value, success, error) {
            window.ga.addCustomDimension(key, value, success, error);
        },
        setUserId: function (id) {
            userId = id;
            window.ga.setUserId(id);
        }
    };
});