/**
 * Module for https://github.com/LuckyKat/phonegap-icloudkv-plugin
 */
bento.define('singletons/icloudkv', [
    'bento',
    'bento/utils'
], function (
    Bento,
    Utils
) {
    'use strict';
    var nothing = function () {};
    var module = {
        write: function (name, object, onSuccess, onFail) {
            // loop through objects and save each value
            Utils.forEach(object, function (value, key, l, breakLoop) {
                window.iCloudKV.save(key, value, function () {});
            });

            // not sure how to check if everything worked so just call success
            if (onSuccess) {
                onSuccess();
            }
        },
        read: function (name, onSuccess, onFail) {
            window.iCloudKV.sync(function (data) {
                // success
                console.log('icloud data sync success');
                if (onSuccess) {
                    onSuccess(data);
                }
            }, function () {
                // fail
                if (onFail) {
                    onFail('icloud data sync failed');
                }
            });
        }
    };

    if (!window.iCloudKV) {
        module.write = function (name, object, onSuccess, onFail) {
            if (onFail) {
                onFail("iCloudKV not available");
            }
        };
        module.read = function (name, onSuccess, onFail) {
            if (onFail) {
                onFail("iCloudKV not available");
            }
        };
    }

    return module;
});