bento.define('singletons/localization', ['bento'], function (Bento) {
    'use strict';
    var languageCode = 'en';
    var names = {};
    var strings = {};
    return {
        getText: function (code) {
            if (!strings.strings || !strings.strings[code]) {
                return '';
            }
            return strings.strings[code];
        },
        // for combocritters: critter names
        getName: function (code) {
            if (!names.strings || !names.strings[code]) {
                return '';
            }
            return names.strings[code];
        },
        setLanguage: function (code) {
            console.log('set language to ' + code);
            try {
                strings = Bento.assets.getJson('text/' + code);
            } catch (e) {
                // in case something terrible happens
                console.log('language json ' + code + ' does not exist!!');
                console.log(e);
            }
            try {
                names = Bento.assets.getJson('names/' + code);
            } catch (e) {
                // in case something terrible happens
                console.log('names json ' + code + ' does not exist!!');
                console.log(e);
            }

            languageCode = code;
        },
        initLanguage: function () {
            var language = window.navigator.userLanguage || window.navigator.language,
                code,
                sub;
            console.log('system lang', language);
            if (language && language.substr) {
                // language.substr(0, 2) === 'zh';
                code = language.substr(0, 2).toLowerCase();
                if (
                    code === 'zh' ||
                    code === 'pt' ||
                    code === 'de' ||
                    code === 'es' ||
                    code === 'fr' ||
                    code === 'it' ||
                    code === 'ja' ||
                    code === 'ko' ||
                    code === 'ru'
                ) {
                    languageCode = code;
                } else {
                    languageCode = 'en';
                }
            }
            // special cases for chinese tradition (zh-TW) and HK (zh-HK):
            // ZT / ZHT, ZHK ?
            if (language.toLowerCase() === 'zh-tw' || language.toLowerCase().indexOf('zh-hant') >= 0) {
                languageCode = 'zt';
            } else if (language.toLowerCase() === 'zh-hk' || language.toLowerCase().indexOf('zh-hans') >= 0) {
                languageCode = 'zt';
            }
                    
            // set language
            this.setLanguage(languageCode);
        },
        getLanguage: function () {
            return languageCode;
        },
        isChinese: function () {
            return languageCode === 'zh' || languageCode === 'zt';
        }
    };
});